#ifndef BINTREE_H
#define BINTREE_H


typedef struct NODE {
	void *key;
	void *data;
	struct NODE *lsub;
	struct NODE *rsub;
} NODE;

typedef struct TREE {
	NODE *root;
	int (*compare)(const void *, const void *);
} TREE;

TREE *new_tree( int (*compare)(const void *, const void *) );
int insert_node( TREE *tree, void *key, void *data );
long foreach_node( TREE *tree, long (*f)(NODE *p, void *aux), void *aux );

#endif
