#include <stdio.h>
#include <string.h>
#include "die.h"

void die( const char *format, ... )
{
	va_list argp;

	va_start( argp, format );
	vfprintf( stderr, format, argp );
	vfprintf( stderr, "\n", argp );
	va_end( argp );

	exit( 1 );
}

void die_io( const char *s )     { perror(s);  die(""); }
void die_mem()                   { die( "out of memory" ); }
void die_syntax( const char *s ) { die("syntax error in input: %s", s);}

void *malloc_or_die( size_t size )
{
	void *p = malloc( size );

	if ( p == NULL )
		die_mem();

	return p;
}

char *strdup_or_die( const char *s )
{
	char *p = strdup( s );

	if ( p == NULL )
		die_mem();

	return p;
}

